001/* 002 * Licensed to the Apache Software Foundation (ASF) under one or more 003 * contributor license agreements. See the NOTICE file distributed with 004 * this work for additional information regarding copyright ownership. 005 * The ASF licenses this file to You under the Apache License, Version 2.0 006 * (the "License"); you may not use this file except in compliance with 007 * the License. You may obtain a copy of the License at 008 * 009 * http://www.apache.org/licenses/LICENSE-2.0 010 * 011 * Unless required by applicable law or agreed to in writing, software 012 * distributed under the License is distributed on an "AS IS" BASIS, 013 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 014 * See the License for the specific language governing permissions and 015 * limitations under the License. 016 */ 017package org.apache.juneau.bean.mcp.v20260728; 018 019import java.util.*; 020 021/** 022 * Shared SEP-2243 routing-name helper used by both the {@code 2026-07-28} server adapter and client adapter. 023 * 024 * @since 10.0.0 025 */ 026public final class McpRoutingNames { 027 028 private McpRoutingNames() {} 029 030 /** 031 * Returns the routing name for {@code Mcp-Name} agreement checks and client header stamping. 032 * 033 * @param method The JSON-RPC method name. 034 * @param params The request params object. 035 * @return The routing name, or empty string. 036 */ 037 public static String routingName(String method, Object params) { 038 var name = switch (method) { 039 case McpMethods.TOOLS_CALL, McpMethods.PROMPTS_GET -> paramValue(params, "name"); 040 case McpMethods.RESOURCES_READ -> paramValue(params, "uri"); 041 default -> ""; 042 }; 043 return name == null ? "" : name; 044 } 045 046 private static String paramValue(Object params, String key) { 047 if (params instanceof Map<?,?> m) { 048 var v = m.get(key); 049 return v == null ? null : v.toString(); 050 } 051 return null; 052 } 053}